diff -Naur src.pgsql/backend/access/bitmap/bitmapinsert.c src.bizgres/backend/access/bitmap/bitmapinsert.c
--- src.pgsql/backend/access/bitmap/bitmapinsert.c	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/access/bitmap/bitmapinsert.c	2006-07-17 22:33:21.000000000 -0700
@@ -0,0 +1,1588 @@
+/*-------------------------------------------------------------------------
+ *
+ * bitmapinsert.c
+ *	  Tuple insertion in the on-disk bitmap index.
+ *
+ * Copyright (c) 2006, Greenplum, Inc.
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL$
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres.h"
+
+#include "access/genam.h"
+#include "access/tupdesc.h"
+#include "access/heapam.h"
+#include "access/bitmap.h"
+#include "parser/parse_oper.h"
+#include "miscadmin.h"
+
+static Buffer _bitmap_get_lastbitmappagebuf(Relation rel, BMLOVItem lovItem);
+static void _bitmap_movetobitmappage(Relation rel, BMLOVItem lovItem,
+									 Buffer* lastBufferP, uint32* numWordsP);
+static void _bitmap_mergewords(Relation rel, BMLOVItem lovItem,
+							   Buffer* lastBufferP, uint32* numWordsP,
+							   uint64 tidNumber);
+static void _bitmap_insertsetbit(Relation rel, BMLOVItem lovItem,
+								 Buffer* lastBufferP, uint32* numWordsP,
+								 uint64 currTidNumber);
+static void _bitmap_create_lovitem
+	(Relation rel, Buffer metabuf, uint64 currTidNumber,
+	 TupleDesc tupDesc, Datum* attdata, bool* nulls,
+	 Relation lovHeap, Relation lovIndex,
+	 BlockNumber* lovBlockP, OffsetNumber* lovOffsetP);
+static void _bitmap_write_tids(Relation rel, Buffer metabuf,
+							   BlockNumber lovBlock, OffsetNumber lovOffset,
+							   uint64* tids, uint32 numTids);
+static void _bitmap_build_inserttuple(Relation rel,
+									  uint64 currTidNumber,
+									  ItemPointerData ht_ctid, TupleDesc tupDesc,
+									  Datum* attdata, bool* nulls,
+									  BMBuildState* state);
+static void _bitmap_inserttuple
+	(Relation rel, Buffer metabuf, uint64 currTidNumber,
+	 ItemPointerData ht_ctid, 
+	 TupleDesc tupDesc, Datum* attdata,
+	 bool* nulls,
+	 Relation lovHeap, Relation lovIndex,
+	 ScanKey scanKey, IndexScanDesc scanDesc);
+
+static void _bitmap_updatesetbit(Relation rel, BMLOVItem lovItem,
+								 Buffer* lastBufferP, uint64 currTidNumber,
+								 uint32* numWordsP);
+static void
+_bitmap_updatesetbit_inword(BM_HRL_WORD word, uint64 updateBitLoc,
+							BM_HRL_WORD* words, BM_HRL_WORD* headerWordP,
+							uint32* numWordsP);
+static void
+_bitmap_updatesetbit_inpage(Relation rel, Buffer bitmapBuffer,
+							Buffer* nextBitmapBufferP, Buffer lastBuffer,
+							uint64 currTidNumber, uint64 firstTidNumber);
+static uint64
+_bitmap_getnumbits(BM_HRL_WORD* contentWords, BM_HRL_WORD* headerWords,
+					uint64 numWords);
+
+static void
+_bitmap_findbitmappage(Relation rel, BMLOVItem lovItem,
+					   Buffer lastBuffer, uint64 currTidNumber,
+					   Buffer* bitmapBufferP, uint64* firstTidNumberP);
+static void
+_bitmap_shift_header_bits(BM_HRL_WORD* words,
+						  uint32 numOfBits,
+						  uint32 maxNumOfWords,
+						  uint32 startLoc,
+						  uint32 numOfShiftingBits);
+static void
+_bitmap_insert_newwords(BM_HRL_WORD* contentWords, BM_HRL_WORD* headerWords,
+						uint32*	numWordsP, uint32 maxNumWords,
+						uint32 insertPos,
+						BM_HRL_WORD* newContentWords, 
+						BM_HRL_WORD  newHeaderWord,
+						uint32 numNewWords,
+						BM_HRL_WORD* leftContentWords,
+						BM_HRL_WORD* leftHeaderWord,
+						uint32* numLeftWordsP);
+
+
+/*
+ * _bitmap_get_lastbitmappagebuf() -- return the buffer for the last 
+ *  bitmap page that is pointed by a given LOV item.
+ *
+ * The returned buffer will hold an exclusive lock.
+ */
+Buffer
+_bitmap_get_lastbitmappagebuf(Relation rel, BMLOVItem lovItem)
+{
+	Buffer lastBuffer = InvalidBuffer;
+
+	if (lovItem->bm_lov_head != InvalidBlockNumber)
+		lastBuffer = _bitmap_getbuf(rel, lovItem->bm_lov_tail, BM_WRITE);
+
+	return lastBuffer;
+}
+
+
+/*
+ * _bitmap_movetobitmappage() -- append bm_last_compword in an LOV item
+ *								 to its associated bitmap page.
+ *
+ * This function moves bm_last_compword in a LOV item into the last
+ * bitmap page that is buffered in *lastBufferP. If *lastBufferP is
+ * not a valid buffer or there is no enough space for the new word,
+ * this function creates a new last bitmap page to store this new word.
+ *
+ * This function increments "*numWordsP" by 1 if the bitmap page pointed
+ * by "*lastBufferP". If "*lastBuffer" does not have enough space for
+ * a new bitmap word, set "*numWordsP" to 1. The '*numWordsP' is used
+ * to indicate how many new words are added to a bitmap page since last
+ * time we have called WAL.
+ */
+void
+_bitmap_movetobitmappage(Relation rel, BMLOVItem lovItem, Buffer* lastBufferP,
+						 uint32* numWordsP)
+{
+	Page			lastPage;
+	BMBitmapOpaque	bitmapPageOpaque;
+	Buffer			newBuffer;
+	BMBitmap		bitmap;
+
+	if (!BufferIsValid(*lastBufferP))
+	{
+		Assert(lovItem->bm_lov_head == InvalidBlockNumber);
+
+		*lastBufferP = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+		lovItem->bm_lov_head = *lastBufferP;
+
+		_bitmap_init_bitmappage(rel, *lastBufferP);
+		_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWBITMAP, 
+							*lastBufferP, NULL);
+
+		lovItem->bm_lov_head = BufferGetBlockNumber(*lastBufferP);
+		lovItem->bm_lov_tail = lovItem->bm_lov_head;
+	}
+
+	lastPage = BufferGetPage(*lastBufferP);
+
+	bitmapPageOpaque = (BMBitmapOpaque)
+		PageGetSpecialPointer(lastPage);
+
+	/* if there is no space in this page */
+	if (bitmapPageOpaque->bm_hrl_words_used == BM_NUM_OF_HRL_WORDS_PER_PAGE)
+	{
+		/* create a new bitmap page, and write the old page to the disk. */
+		newBuffer = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+		_bitmap_init_bitmappage(rel, newBuffer);
+
+		_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWBITMAP, 
+							newBuffer, NULL);
+
+		lovItem->bm_lov_tail = BufferGetBlockNumber(newBuffer);
+		bitmapPageOpaque->bm_bitmap_next = lovItem->bm_lov_tail;
+
+		_bitmap_log_bitmappage(rel, *lastBufferP, true, *numWordsP);
+		_bitmap_wrtbuf(*lastBufferP);
+
+		*numWordsP = 0;
+		*lastBufferP = newBuffer;
+		lastPage = BufferGetPage(*lastBufferP);
+		bitmapPageOpaque = (BMBitmapOpaque)
+			PageGetSpecialPointer(lastPage);
+
+	}
+
+	bitmap = (BMBitmap) PageGetContents(lastPage);
+
+	if (lovItem->bm_last_two_headerbits == 2 ||
+		lovItem->bm_last_two_headerbits == 3)
+		bitmap->bm_headerWords
+			[(bitmapPageOpaque->bm_hrl_words_used/BM_HRL_WORD_SIZE)] |=
+			(1<<(BM_HRL_WORD_SIZE-1-
+				 (bitmapPageOpaque->bm_hrl_words_used%BM_HRL_WORD_SIZE)));
+	bitmap->bm_contentWords[bitmapPageOpaque->bm_hrl_words_used] =
+		lovItem->bm_last_compword;
+
+	bitmapPageOpaque->bm_last_tid_location = lovItem->bm_last_tid_location;
+	bitmapPageOpaque->bm_hrl_words_used++;
+	(*numWordsP) ++;
+}
+
+/*
+ * _bitmap_mergewords() -- merge bm_last_word into bm_last_compword
+ * 	in a given LOV item.
+ *
+ * If bm_last_word and bm_last_compword can be compressed into one word,
+ * then simply update the value for bm_last_compword, and reset
+ * bm_last_word.
+ *
+ * If bm_last_word and bm_last_compword can not be compressed into one word,
+ * we append bm_last_compword into the last bitmap page, set
+ * bm_last_compword to bm_last_word, and reset bm_last_word.
+ */
+void
+_bitmap_mergewords(Relation rel, BMLOVItem lovItem,
+				   Buffer* lastBufferP, uint32* numWordsP, uint64 tidNumber)
+{
+	bool lastWordIsFill = 
+			(lovItem->bm_last_two_headerbits == 1 ||
+			 lovItem->bm_last_two_headerbits == 3);
+
+	/*
+	 * If two words are both fill word, then try to increase the
+	 * fill length in bm_last_compword. If this fill length exceeds
+	 * the maximum fill length, then write it out to disk, and create
+	 * a new word for bm_last_compword.
+	 */
+	if ((lovItem->bm_last_two_headerbits == 3) &&
+		(GET_FILL_BIT(lovItem->bm_last_compword) ==
+		 GET_FILL_BIT(lovItem->bm_last_word)))
+	{
+		BM_HRL_WORD	lastCompWordFillLength = 
+			FILL_LENGTH(lovItem->bm_last_compword);
+		BM_HRL_WORD lastWordFillLength =
+			FILL_LENGTH(lovItem->bm_last_word);
+
+		if (lastCompWordFillLength+lastWordFillLength >= MAX_FILL_LENGTH) {
+			lovItem->bm_last_compword += 
+				(MAX_FILL_LENGTH-lastCompWordFillLength);
+			lovItem->bm_last_word -=
+				(MAX_FILL_LENGTH-lastCompWordFillLength);
+			lovItem->bm_last_tid_location +=
+				(MAX_FILL_LENGTH-lastCompWordFillLength)*BM_HRL_WORD_SIZE;
+
+			_bitmap_movetobitmappage(rel, lovItem, lastBufferP, numWordsP);
+			lovItem->bm_last_compword  = lovItem->bm_last_word;
+			lovItem->bm_last_tid_location +=
+				FILL_LENGTH(lovItem->bm_last_compword)*BM_HRL_WORD_SIZE;
+		}
+
+		else
+		{
+			lovItem->bm_last_compword += lastWordFillLength;
+			lovItem->bm_last_tid_location +=
+				lastWordFillLength*BM_HRL_WORD_SIZE;
+		}
+
+		lovItem->bm_last_two_headerbits = 2;
+	}
+	else
+	{
+		if (tidNumber != BM_HRL_WORD_SIZE)
+			_bitmap_movetobitmappage(rel, lovItem, lastBufferP, numWordsP);
+
+		/* move the last word to the last complete word. */
+		lovItem->bm_last_compword = lovItem->bm_last_word;
+
+		if (lastWordIsFill)
+		{
+			lovItem->bm_last_two_headerbits = 2;
+			lovItem->bm_last_tid_location +=
+				FILL_LENGTH(lovItem->bm_last_compword)*BM_HRL_WORD_SIZE;
+		}
+		else
+		{
+			lovItem->bm_last_two_headerbits = 0;
+			lovItem->bm_last_tid_location += BM_HRL_WORD_SIZE;
+		}
+	}
+
+	lovItem->bm_last_word = LITERAL_ALL_ZERO;
+}
+
+/*
+ * _bitmap_getnumbits() -- return the number of bits included in the given
+ * 	bitmap words.
+ */
+uint64
+_bitmap_getnumbits(BM_HRL_WORD* contentWords, BM_HRL_WORD* headerWords,
+					uint64 numWords) {
+	uint64	numBits = 0;
+	uint32	wordNo;
+
+	for (wordNo=0; wordNo<numWords; wordNo++) {
+		if (IS_FILL_WORD(headerWords, wordNo))
+			numBits += FILL_LENGTH(contentWords[wordNo]) * BM_HRL_WORD_SIZE;
+		else
+			numBits += BM_HRL_WORD_SIZE;
+	}
+
+	return numBits;
+}
+
+/*
+ * _bitmap_updatesetbit() -- update a set bit in a bitmap.
+ *
+ * This function finds the bit in a given bitmap vector whose bit location is
+ * equal to currTidNumber, and changes this bit to 1.
+ *
+ * If this bit is already 1, then we are done. Otherwise, there are
+ * two possibilities:
+ * (1) This bit appears in a literal word. In this case, we simply change
+ *     it to 1.
+ * (2) This bit appears in a fill word with bit 0. In this case, this word
+ *     may generate two or three words after changing the corresponding bit
+ *     to 1, depending on the position of this bit.
+ *
+ * Case (2) will make the corresponding bitmap page to grow. The words after
+ * this affected word in this bitmap page are shifted right to accommodate
+ * the newly generated words. If this bitmap page does not have enough space
+ * to hold all these words, the last few words will be shifted out of this
+ * page. In this case, the next bitmap page is checked to see if there are
+ * enough space for these extra words. If so, these extra words are inserted
+ * into the next page. Otherwise, we create a new bitmap page to hold
+ * these extra words.
+ */
+void
+_bitmap_updatesetbit(Relation rel, BMLOVItem lovItem,
+					 Buffer* lastBufferP, uint64 currTidNumber,
+					 uint32* numWordsP)
+{
+	uint64	tidLocation;
+	uint16	insertingPos;
+
+	/* Calculate the tid location in the last bitmap page. */
+	tidLocation = lovItem->bm_last_tid_location;
+	if (lovItem->bm_last_two_headerbits == 2)
+		tidLocation -= (FILL_LENGTH(lovItem->bm_last_compword)*
+					    BM_HRL_WORD_SIZE);
+	else
+		tidLocation -= BM_HRL_WORD_SIZE;
+
+	/*
+	 * If currTidNumber is in either bm_last_compword or bm_last_word,
+	 * we simply change it. Otherwise, we have to find the right page
+	 * that contains this bit, starting from the beginning of the
+	 * bitmap vector.
+	 */
+	if (currTidNumber > lovItem->bm_last_tid_location)   /* bm_last_word */
+	{
+		insertingPos = BM_HRL_WORD_SIZE - 
+				((currTidNumber-1)%BM_HRL_WORD_SIZE) - 1 ;
+		lovItem->bm_last_word |= (((BM_HRL_WORD)1)<<insertingPos);
+	}
+	else if (currTidNumber > tidLocation)   /* bm_last_compword */
+	{
+		/* if this is a literal word, we simply update the bit. */
+		if (lovItem->bm_last_two_headerbits == 0)
+		{
+			insertingPos = BM_HRL_WORD_SIZE -
+				((currTidNumber-1)%BM_HRL_WORD_SIZE) - 1;
+			lovItem->bm_last_compword |= (((BM_HRL_WORD)1)<<insertingPos);
+		}
+
+		/*
+		 * If this is a fill zero word, we need to split this word
+		 * into two or three words, depending on the splitting position.
+		 */
+		else if (lovItem->bm_last_two_headerbits == 2 &&
+				 GET_FILL_BIT(lovItem->bm_last_compword) == 0)
+		{
+			BM_HRL_WORD	newContentWords[3];
+			BM_HRL_WORD newHeaderWord;
+			uint32	numNewWords;
+			uint32	newWordNo;
+
+			_bitmap_updatesetbit_inword(lovItem->bm_last_compword,
+										currTidNumber-tidLocation-1,
+										newContentWords, &newHeaderWord,
+										&numNewWords);
+
+			/* reset lovItem->bm_last_tid_location */
+			lovItem->bm_last_tid_location = tidLocation;
+
+			for (newWordNo=0; newWordNo<numNewWords; newWordNo++)
+			{
+				lovItem->bm_last_compword = newContentWords[newWordNo];
+				if (IS_FILL_WORD(&newHeaderWord, newWordNo))
+				{
+					lovItem->bm_last_two_headerbits = 2;
+					lovItem->bm_last_tid_location +=
+						FILL_LENGTH(lovItem->bm_last_compword)*
+						BM_HRL_WORD_SIZE;
+				}
+				else {
+					lovItem->bm_last_two_headerbits = 0;
+					lovItem->bm_last_tid_location += BM_HRL_WORD_SIZE;
+				}
+
+				if (newWordNo != numNewWords-1)
+					_bitmap_movetobitmappage(rel, lovItem,
+											 lastBufferP, numWordsP);
+			}
+		}
+	}
+
+	/*
+	 * If currTidNumber is in the middle of the bitmap vector,
+	 * we try to find the bitmap page that contains this bit,
+	 * and update the bit.
+	 */
+	else {
+
+		/* find the page that contains this bit. */
+		uint64	firstTidNumber = 1;
+		Buffer	bitmapBuffer;
+		Page	bitmapPage;
+		BMBitmapOpaque	bitmapOpaque;
+
+		Buffer	nextBuffer = InvalidBuffer;
+
+		_bitmap_findbitmappage(rel, lovItem,
+							   *lastBufferP, currTidNumber,
+							   &bitmapBuffer, &firstTidNumber);
+
+		/*
+		 * We may need the next page of this page when we update the bit
+		 * in this page, because if there are enough space in the next
+		 * page to hold the extra words generated by this update, we
+		 * will insert them into the next page.
+		 */
+		bitmapPage = BufferGetPage(bitmapBuffer);
+		bitmapOpaque = (BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);
+		if (BlockNumberIsValid(bitmapOpaque->bm_bitmap_next))
+		{
+			if (bitmapOpaque->bm_bitmap_next != lovItem->bm_lov_tail)
+				nextBuffer =
+					_bitmap_getbuf(rel, bitmapOpaque->bm_bitmap_next,
+								   BM_WRITE);
+			else
+				nextBuffer = *lastBufferP;
+		}
+
+		_bitmap_updatesetbit_inpage(rel, bitmapBuffer,
+									&nextBuffer, *lastBufferP,
+									currTidNumber, firstTidNumber);
+
+		if (bitmapBuffer == *lastBufferP &&
+			BufferIsValid(nextBuffer))
+		{
+			_bitmap_log_bitmappage(rel, bitmapBuffer, false,
+								   bitmapOpaque->bm_hrl_words_used);
+			_bitmap_wrtbuf(bitmapBuffer);
+
+			*lastBufferP = nextBuffer;
+			lovItem->bm_lov_tail = BufferGetBlockNumber(nextBuffer);
+		}
+
+		else if (BufferIsValid(nextBuffer)) {
+			_bitmap_log_bitmappage(rel, bitmapBuffer, false,
+									bitmapOpaque->bm_hrl_words_used);
+			_bitmap_wrtbuf(bitmapBuffer);
+			if (nextBuffer != *lastBufferP)
+			{
+				Page nextPage = BufferGetPage(nextBuffer);
+				BMBitmapOpaque nextBitmapOpaque =
+					(BMBitmapOpaque)PageGetSpecialPointer(nextPage);
+
+				_bitmap_log_bitmappage(rel, nextBuffer, false,
+									   nextBitmapOpaque->bm_hrl_words_used);
+				_bitmap_wrtbuf(nextBuffer);
+			}
+		}
+	}
+}
+
+/*
+ * _bitmap_updatesetbit_inword() -- update the given bit to 1 in a given
+ * 	word.
+ *
+ * The given word will generate at most three new words, depending on 
+ * the position of the given bit to be updated. Make sure that the 
+ * array 'words' has the size of 3 when you call this function. All new 
+ * words will be put in this array, and the final number of new words is 
+ * stored in '*numWordsP'. The bit location 'updateBitLoc' is relative to
+ * the beginning of the given word, starting from 0.
+ *
+ * We assume that word is a fill zero word.
+ */
+void
+_bitmap_updatesetbit_inword(BM_HRL_WORD word, uint64 updateBitLoc,
+							BM_HRL_WORD* words, BM_HRL_WORD* headerWordP,
+							uint32* numWordsP)
+{
+	uint64	numBits, usedNumBits;
+	uint16	insertingPos;
+
+	*numWordsP = 0;
+	*headerWordP = 0;
+
+	Assert(updateBitLoc < BM_HRL_WORD_SIZE*FILL_LENGTH(word));
+
+	numBits = FILL_LENGTH(word) * BM_HRL_WORD_SIZE;
+	usedNumBits = 0;
+	if (updateBitLoc >= BM_HRL_WORD_SIZE)
+	{
+		words[*numWordsP] =
+			BM_MAKE_FILL_WORD(0, updateBitLoc/BM_HRL_WORD_SIZE);
+		(*numWordsP) ++;
+		*headerWordP |=	(1<<(BM_HRL_WORD_SIZE-*numWordsP));
+		usedNumBits += (updateBitLoc/BM_HRL_WORD_SIZE) * BM_HRL_WORD_SIZE;
+	}
+
+	/* construct the literal word */
+	insertingPos = BM_HRL_WORD_SIZE - (updateBitLoc-usedNumBits) - 1;
+	words[*numWordsP] = ((BM_HRL_WORD)0) | (1<<insertingPos);
+	(*numWordsP) ++;
+	usedNumBits += BM_HRL_WORD_SIZE;
+
+	if (numBits > usedNumBits)
+	{
+		Assert((numBits-usedNumBits)%BM_HRL_WORD_SIZE == 0);
+
+		words[*numWordsP] = 
+			BM_MAKE_FILL_WORD(0, (numBits-usedNumBits)/BM_HRL_WORD_SIZE);
+		(*numWordsP) ++;
+		*headerWordP |=	(1<<(BM_HRL_WORD_SIZE-*numWordsP));
+	}
+}
+
+/*
+ * _bitmap_shift_header_bits() -- right-shift bits after 'startLoc' for
+ * 	'numofShiftingBits' bits.
+ *
+ * These bits are stored in an array of words with the word size of
+ * BM_HRL_WORD_SIZE. This shift is done in-place. The maximum number of
+ * words in this array is given. If the shifting causes the array does not
+ * have enough space for all bits, the right-most overflow bits will be
+ * discarded. The value 'startLoc' starts with 0.
+ */
+void
+_bitmap_shift_header_bits(BM_HRL_WORD* words,
+						  uint32 numOfBits,
+						  uint32 maxNumOfWords,
+						  uint32 startLoc,
+						  uint32 numOfShiftingBits)
+{
+	uint32	startWordNo;
+	uint32	endWordNo;
+	uint32	wordNo;
+	uint32	numOfFinalShiftingBits;
+	BM_HRL_WORD tmpWord;
+
+	Assert(startLoc <= numOfBits);
+	Assert((numOfBits-1)/BM_HRL_WORD_SIZE < maxNumOfWords);
+
+	startWordNo = startLoc/BM_HRL_WORD_SIZE;
+	endWordNo = (numOfBits-1)/BM_HRL_WORD_SIZE;
+
+	for (wordNo=endWordNo; wordNo>startWordNo; wordNo--) {
+		/*
+		 * obtain the last 'numOfShiftingBits' bits in the words[wordNo],
+		 * and store them in the high-end of a word.
+		 */
+		tmpWord = (((BM_HRL_WORD)words[wordNo])<<
+					(BM_HRL_WORD_SIZE-numOfShiftingBits));
+
+		/* right-shift the original word 'numOfShiftingBits' bits. */
+		words[wordNo] =
+			(((BM_HRL_WORD)words[wordNo])>>numOfShiftingBits);
+
+		/* OR those shifted bits into the next word in the array. */
+		if (wordNo < maxNumOfWords-1)
+			words[wordNo+1] |= tmpWord;
+		
+	}
+
+	/* obtain bits after 'startLoc'.*/
+	tmpWord = ((BM_HRL_WORD)(words[startWordNo]<<
+				(startLoc%BM_HRL_WORD_SIZE)))>>(startLoc%BM_HRL_WORD_SIZE);
+
+	words[startWordNo] =
+		((BM_HRL_WORD)(words[startWordNo]>>
+			(BM_HRL_WORD_SIZE-startLoc%BM_HRL_WORD_SIZE)))<<
+			(BM_HRL_WORD_SIZE-startLoc%BM_HRL_WORD_SIZE);
+
+	numOfFinalShiftingBits = numOfShiftingBits;
+	if (BM_HRL_WORD_SIZE-startLoc%BM_HRL_WORD_SIZE < numOfShiftingBits)
+		numOfFinalShiftingBits =
+			BM_HRL_WORD_SIZE - startLoc%BM_HRL_WORD_SIZE;
+
+	words[startWordNo] |= (tmpWord>>numOfFinalShiftingBits);
+
+	if (startWordNo < maxNumOfWords-1) {
+		tmpWord =
+			((BM_HRL_WORD)(tmpWord<<(BM_HRL_WORD_SIZE-numOfFinalShiftingBits)))>>
+			(numOfShiftingBits-numOfFinalShiftingBits);
+		words[startWordNo+1] |= tmpWord;
+	}
+}
+
+/*
+ * _bitmap_insert_newwords() -- insert some given words into an array
+ *	of bitmap words.
+ *
+ * The new words will be inserted into the positions starting from
+ * 'insertPos'(>=0). The original words from 'insertPos' will be shifted
+ * to the right. If the given array does not have enough space to
+ * hold all words, the last '(*numWordsP+numNewWords-maxNumWords)' words
+ * will be stored in 'leftWords', for which the caller should set
+ * the enough space to hold these left words. '*numWordsP' will be
+ * set to the final total number of words in this array.
+ *
+ * The 'numNewWords' is less than or equal to BM_HRL_WORD_SIZE.
+ */
+void
+_bitmap_insert_newwords(BM_HRL_WORD* contentWords, BM_HRL_WORD* headerWords,
+						uint32*	numWordsP, uint32 maxNumWords,
+						uint32 insertPos,
+						BM_HRL_WORD* newContentWords, 
+						BM_HRL_WORD  newHeaderWord,
+						uint32 numNewWords,
+						BM_HRL_WORD* leftContentWords,
+						BM_HRL_WORD* leftHeaderWord,
+						uint32* numLeftWordsP)
+{
+	int32	wordNo;
+	uint16  bitLoc;
+
+	Assert(numNewWords <= BM_HRL_WORD_SIZE);
+	Assert(insertPos <= maxNumWords);
+
+	*numLeftWordsP = 0;
+
+	/* if there are no words in this page, we simply copy the new words. */
+	if (*numWordsP == 0)
+	{
+		memcpy(contentWords, newContentWords, numNewWords*sizeof(BM_HRL_WORD));
+		memcpy(headerWords, &newHeaderWord, sizeof(BM_HRL_WORD));
+		*numWordsP = numNewWords;
+
+		return;
+	}
+
+	/*
+	 * if insertPos is pointing to the position after the maximum position
+	 * in this word, we simply copy the new words to leftContentWords.
+	 */
+	if (insertPos == maxNumWords)
+	{
+		memcpy(leftContentWords, newContentWords,
+				numNewWords*sizeof(BM_HRL_WORD));
+		memcpy(leftHeaderWord, &newHeaderWord, sizeof(BM_HRL_WORD));
+		*numLeftWordsP = numNewWords;
+
+		return;
+	}
+
+	Assert(*numWordsP > 0);
+
+	if (*numWordsP + numNewWords > maxNumWords)
+		*numLeftWordsP = *numWordsP + numNewWords - maxNumWords;
+	*leftHeaderWord = 0;
+
+	/*
+	 * Walk from the last word in the array back to 'insertPos'.
+	 * If the word no + numNewWords is greater than maxNumWords,
+	 * we store these words in leftContentWords.
+	 */
+	for (wordNo=*numWordsP-1; wordNo>=0 && wordNo>=insertPos; wordNo--)
+	{
+		if (wordNo+numNewWords >= maxNumWords)
+		{
+			leftContentWords[wordNo+numNewWords-maxNumWords] = 
+				contentWords[wordNo];
+			if (IS_FILL_WORD(headerWords, wordNo))
+			{
+				*leftHeaderWord |=
+					(((BM_HRL_WORD)1)<<(BM_HRL_WORD_SIZE-
+						(wordNo+numNewWords-maxNumWords)-1));
+				headerWords[wordNo/BM_HRL_WORD_SIZE] &=
+					(~(((BM_HRL_WORD)1) << (BM_HRL_WORD_SIZE-1-
+						((wordNo)%BM_HRL_WORD_SIZE))));
+			}
+		}
+		else
+			contentWords[wordNo+numNewWords] = contentWords[wordNo];
+	}
+
+	/* insert new words */
+	for (wordNo=0; wordNo<numNewWords; wordNo++)
+	{
+		if (insertPos+wordNo>= maxNumWords)
+		{
+			leftContentWords[insertPos+wordNo-maxNumWords] =
+				newContentWords[wordNo];
+			if (IS_FILL_WORD(&newHeaderWord, wordNo))
+				*leftHeaderWord |=
+					(((BM_HRL_WORD)1)<<(BM_HRL_WORD_SIZE-
+										(insertPos+wordNo-maxNumWords)-1));
+		}
+
+		else {
+			contentWords[insertPos+wordNo] = newContentWords[wordNo];
+		}
+	}
+
+	
+
+	/* right-shift the bits in the header words */
+	_bitmap_shift_header_bits(headerWords,
+							  *numWordsP,
+							  BM_MAX_NUM_OF_HEADER_WORDS,
+							  insertPos,
+							  numNewWords);
+
+	/* set the newWords header bits */
+	for (bitLoc=insertPos;
+		 bitLoc<insertPos+numNewWords && bitLoc<maxNumWords;
+		 bitLoc++)
+	{
+		if (IS_FILL_WORD(&newHeaderWord, bitLoc-insertPos))
+			headerWords[bitLoc/BM_HRL_WORD_SIZE] |=
+				(((BM_HRL_WORD)1)<<
+					(BM_HRL_WORD_SIZE-1-bitLoc%BM_HRL_WORD_SIZE));
+	}
+
+	*numWordsP += (numNewWords-*numLeftWordsP);
+}
+						
+
+/*
+ * _bitmap_updatesetbit_inpage() -- update the given bit to 1 in a given
+ *	bitmap page.
+ *
+ * The argument 'firstTidNumber' indicates the first tid location of
+ * the bits stored in this page. This is necessary for locating the bit
+ * of 'currTidNumber'.
+ */
+void
+_bitmap_updatesetbit_inpage(Relation rel, Buffer bitmapBuffer,
+							Buffer* nextBitmapBufferP, Buffer lastBuffer,
+							uint64 currTidNumber, uint64 firstTidNumber)
+{
+	Page 			bitmapPage;
+	BMBitmapOpaque	bitmapOpaque;
+	BMBitmap		bitmap;
+	uint64			bitNo = 0;
+	uint32			wordNo;
+	BM_HRL_WORD		word;
+
+	bitmapPage = BufferGetPage(bitmapBuffer);
+	bitmapOpaque = (BMBitmapOpaque)PageGetSpecialPointer(bitmapPage);
+
+	bitmap = (BMBitmap) PageGetContents(bitmapPage);
+	bitNo = 0;
+
+	/* Find the word that contains the bit of currTidNumber. */
+	for (wordNo = 0; wordNo<bitmapOpaque->bm_hrl_words_used; wordNo++)
+	{
+		word = bitmap->bm_contentWords[wordNo];
+		if (IS_FILL_WORD(bitmap->bm_headerWords, wordNo))
+			bitNo += FILL_LENGTH(word) * BM_HRL_WORD_SIZE;
+		else
+			bitNo += BM_HRL_WORD_SIZE;
+
+		if (firstTidNumber + bitNo - 1 >= currTidNumber)
+			break;		/* find the word */
+	}
+
+	Assert (wordNo < bitmapOpaque->bm_hrl_words_used);
+
+	if (!IS_FILL_WORD(bitmap->bm_headerWords, wordNo))
+	{
+		uint16 insertingPos = BM_HRL_WORD_SIZE -
+				((currTidNumber-1)%BM_HRL_WORD_SIZE) - 1;
+
+		bitmap->bm_contentWords[wordNo] |= (1<<insertingPos);
+	}
+
+	else if (GET_FILL_BIT(word) == 0)
+	{
+		BM_HRL_WORD newContentWords[3];
+		BM_HRL_WORD	newHeaderWord;
+		uint32		numNewWords;
+
+		firstTidNumber = firstTidNumber + bitNo -
+						 FILL_LENGTH(word) * BM_HRL_WORD_SIZE;
+		
+		/* update the bit in 'word', and generate new words */
+		_bitmap_updatesetbit_inword(word,
+									currTidNumber-firstTidNumber,
+									newContentWords, &newHeaderWord,
+									&numNewWords);
+
+		if (numNewWords == 1)
+		{
+			bitmap->bm_contentWords[wordNo] = newContentWords[0];
+			bitmap->bm_headerWords[wordNo/BM_HRL_WORD_SIZE] &=
+				(~(1<<(BM_HRL_WORD_SIZE-1-wordNo%BM_HRL_WORD_SIZE)));
+		}
+
+		else
+		{
+			BM_HRL_WORD leftContentWords[3];
+			BM_HRL_WORD leftHeaderWord;
+			uint32		numLeftWords;
+			Buffer		newBitmapBuffer = InvalidBuffer;
+			Page		newBitmapPage;
+			BMBitmapOpaque newBitmapOpaque;
+			BMBitmap	newBitmap;
+			BM_HRL_WORD newLeftContentWords[3];
+			BM_HRL_WORD	newLeftHeaderWord;
+			uint32		numNewLeftWords;
+			uint64		oldTidLocation;
+
+			bitmap->bm_contentWords[wordNo] = newContentWords[0];
+			if (currTidNumber-firstTidNumber+1<=BM_HRL_WORD_SIZE)
+				bitmap->bm_headerWords[wordNo/BM_HRL_WORD_SIZE] &=
+					(~(((BM_HRL_WORD)1<<
+						(BM_HRL_WORD_SIZE-1-wordNo%BM_HRL_WORD_SIZE))));
+
+			/* ignore the first word in newContentWords. */
+			newHeaderWord = newHeaderWord << 1;
+			_bitmap_insert_newwords(bitmap->bm_contentWords,
+									bitmap->bm_headerWords,
+									&(bitmapOpaque->bm_hrl_words_used),
+									BM_NUM_OF_HRL_WORDS_PER_PAGE,
+									wordNo+1,
+									newContentWords+1, newHeaderWord,
+									numNewWords-1,
+									leftContentWords, &leftHeaderWord,
+									&numLeftWords);
+			if (numLeftWords == 0)
+				return;
+
+			oldTidLocation = bitmapOpaque->bm_last_tid_location;
+			bitmapOpaque->bm_last_tid_location -=
+				_bitmap_getnumbits(leftContentWords, &leftHeaderWord,
+								   numLeftWords);
+
+			/*
+			 * if this page does not have enough space for these new words,
+			 * we look at the next page. If the next page has enough space for
+			 * the left words, we insert them into the next page. Otherwise,
+			 * we create a new page to hold these words.
+			 */
+			if (BufferIsValid(*nextBitmapBufferP))
+			{
+				Page nextBitmapPage = BufferGetPage(*nextBitmapBufferP);
+				BMBitmapOpaque	nextBitmapOpaque =
+					(BMBitmapOpaque)PageGetSpecialPointer(nextBitmapPage);
+
+				if (nextBitmapOpaque->bm_hrl_words_used + numLeftWords <=
+					BM_NUM_OF_HRL_WORDS_PER_PAGE)
+					newBitmapBuffer = *nextBitmapBufferP;
+			}
+
+			if (!BufferIsValid(newBitmapBuffer))
+			{
+				newBitmapBuffer = 
+					_bitmap_getbuf(rel, P_NEW, BM_WRITE);
+				_bitmap_init_bitmappage(rel, newBitmapBuffer);
+				_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWBITMAP,
+									newBitmapBuffer, NULL);
+
+				bitmapOpaque->bm_bitmap_next =
+					BufferGetBlockNumber(newBitmapBuffer);
+			}
+
+			newBitmapPage = BufferGetPage(newBitmapBuffer);
+			newBitmapOpaque =
+				(BMBitmapOpaque)PageGetSpecialPointer(newBitmapPage);
+
+			if (BufferIsValid(*nextBitmapBufferP) &&
+				*nextBitmapBufferP != newBitmapBuffer)
+			{
+				newBitmapOpaque->bm_last_tid_location = oldTidLocation;
+				newBitmapOpaque->bm_bitmap_next =
+					BufferGetBlockNumber(*nextBitmapBufferP);
+				if (*nextBitmapBufferP != lastBuffer)
+					_bitmap_relbuf(*nextBitmapBufferP);
+			} else if (!BufferIsValid(*nextBitmapBufferP))
+				newBitmapOpaque->bm_last_tid_location = oldTidLocation;
+					
+			*nextBitmapBufferP = newBitmapBuffer;
+
+			newBitmap = (BMBitmap)PageGetContents(newBitmapPage);
+	
+			_bitmap_insert_newwords(newBitmap->bm_contentWords,
+									newBitmap->bm_headerWords,
+									&(newBitmapOpaque->bm_hrl_words_used),
+									BM_NUM_OF_HRL_WORDS_PER_PAGE,
+									0,
+									leftContentWords, leftHeaderWord,
+									numLeftWords,
+									newLeftContentWords, &newLeftHeaderWord,
+									&numNewLeftWords);
+
+			Assert(numNewLeftWords == 0);
+		}
+	}
+}
+
+/*
+ * _bitmap_findbitmappage() -- find the bitmap page that contains
+ *	the given tid location.
+ *
+ * We assume that this tid location is not in bm_last_compword or
+ * bm_last_word of its LOVItem.
+ */
+void
+_bitmap_findbitmappage(Relation rel, BMLOVItem lovItem,
+					   Buffer lastBuffer, uint64 currTidNumber,
+					   Buffer* bitmapBufferP, uint64* firstTidNumberP)
+{
+	BlockNumber nextBlockNo = lovItem->bm_lov_head;
+
+	while (BlockNumberIsValid(nextBlockNo))
+	{
+		Page bitmapPage;
+		BMBitmapOpaque bitmapOpaque;
+
+		/*
+		 * if this is the last page, verify if currTidNumber is in
+		 * this page, and set returnBuffer to *lastBufferP. Note that
+		 * we already have the write lock on this page.
+		 */
+		if (nextBlockNo == lovItem->bm_lov_tail)
+		{
+			bitmapPage = (Page)BufferGetPage(lastBuffer);
+			bitmapOpaque = (BMBitmapOpaque)
+				PageGetSpecialPointer(bitmapPage);
+			Assert(bitmapOpaque->bm_last_tid_location >= currTidNumber);
+			*bitmapBufferP = lastBuffer;
+			break;
+		}
+
+		*bitmapBufferP = _bitmap_getbuf(rel, nextBlockNo, BM_READ);
+		bitmapPage = BufferGetPage(*bitmapBufferP);
+		bitmapOpaque = (BMBitmapOpaque)
+			PageGetSpecialPointer(bitmapPage);
+
+		if (bitmapOpaque->bm_last_tid_location >= currTidNumber)
+			break;   		/* find the page */
+
+		(*firstTidNumberP) = bitmapOpaque->bm_last_tid_location + 1;
+		nextBlockNo = bitmapOpaque->bm_bitmap_next;
+
+		_bitmap_relbuf(*bitmapBufferP);
+	}
+}
+
+
+/*
+ * _bitmap_insertsetbit() -- insert a set bit into a bitmap.
+ */
+void
+_bitmap_insertsetbit(Relation rel, BMLOVItem lovItem,
+					 Buffer* lastBufferP, uint32* numWordsP,
+					 uint64 currTidNumber)
+{
+	int32		numOfZeros;
+	uint16		zerosNeeded, insertingPos;
+
+	/*
+	 * If this is the first time to insert a set bit, then
+	 * we have already inserted the first currTidNumber/BM_HRL_WORD_SIZE
+	 * zeros.
+	 */
+	if (lovItem->bm_last_setbit == 0)
+		numOfZeros = currTidNumber%BM_HRL_WORD_SIZE;
+	else
+	{
+		/*
+		 * Usually, currTidNumber is greater than lovItem->bm_last_setbit.
+		 * However, if this is not the case, this should be called while
+		 * doing 'vacuum full' or doing insertion after 'vacuum'. In this
+		 * case, we try to update this bit in the corresponding bitmap
+		 * vector.
+		 */
+		if (currTidNumber <= lovItem->bm_last_setbit)
+		{
+			/*
+			 * Scan through the bitmap vector, and update the bit in
+			 * currTidNumber.
+			 */
+			_bitmap_updatesetbit(rel, lovItem, lastBufferP,
+								 currTidNumber, numWordsP);
+
+			return;
+		}
+		numOfZeros = currTidNumber - lovItem->bm_last_setbit - 1;
+	}
+
+	/*
+	 * If there are some zeros between these two set bits, then
+	 * we need to fill these zero bits into the bitmap.
+	 */
+	if (numOfZeros > 0){
+
+		/* try to fill bm_last_word */
+		if (lovItem->bm_last_setbit == 0)
+			zerosNeeded = BM_HRL_WORD_SIZE;
+		else
+			zerosNeeded = BM_HRL_WORD_SIZE - 
+				((lovItem->bm_last_setbit-1)%BM_HRL_WORD_SIZE) - 1 ;
+		if ((zerosNeeded != 0) && (numOfZeros >= zerosNeeded))
+		{
+			/* merge bm_last_word into bm_last_compword */
+			_bitmap_mergewords (rel, lovItem, lastBufferP, numWordsP,
+								(lovItem->bm_last_setbit+zerosNeeded));
+
+			numOfZeros -= zerosNeeded;
+		}
+
+		/*
+		 * if the remaining zeros are more than BM_HRL_WORD_SIZE,
+		 * we construct the last word to be a fill word, and merge it
+		 * with bm_last_compword.
+		 */
+		if (numOfZeros >= BM_HRL_WORD_SIZE)
+		{
+			uint32	numOfTotalFillWords = numOfZeros/BM_HRL_WORD_SIZE;
+			uint32	loopNo=0;
+
+			while (numOfTotalFillWords > 0) {
+				BM_HRL_WORD numOfFillWords ;
+				if (numOfTotalFillWords >= MAX_FILL_LENGTH)
+					numOfFillWords = MAX_FILL_LENGTH;
+				else
+					numOfFillWords = numOfTotalFillWords;
+
+				lovItem->bm_last_word = 
+					BM_MAKE_FILL_WORD(0, numOfFillWords);
+				lovItem->bm_last_two_headerbits |= 1;
+				_bitmap_mergewords (rel, lovItem, lastBufferP, numWordsP,
+					(lovItem->bm_last_setbit+zerosNeeded+
+					loopNo*MAX_FILL_LENGTH*BM_HRL_WORD_SIZE+
+					numOfFillWords*BM_HRL_WORD_SIZE));
+				loopNo++;
+
+				numOfTotalFillWords -= numOfFillWords;
+				numOfZeros -= numOfFillWords*BM_HRL_WORD_SIZE;
+			}
+		}
+	}
+
+	Assert((numOfZeros >= 0) && (numOfZeros<BM_HRL_WORD_SIZE));
+
+	insertingPos = BM_HRL_WORD_SIZE - 
+			((currTidNumber-1)%BM_HRL_WORD_SIZE) - 1 ;
+	lovItem->bm_last_word |= (1<<insertingPos);
+	lovItem->bm_last_setbit = currTidNumber;
+	
+	if (currTidNumber%BM_HRL_WORD_SIZE == 0)
+	{
+		if (lovItem->bm_last_word == LITERAL_ALL_ZERO)
+		{
+			lovItem->bm_last_word =
+				BM_MAKE_FILL_WORD(0, 1);
+			lovItem->bm_last_two_headerbits |= 1;
+		}
+
+		else if (lovItem->bm_last_word == LITERAL_ALL_ONE)
+		{
+			lovItem->bm_last_word =
+				BM_MAKE_FILL_WORD(1, 1);
+			lovItem->bm_last_two_headerbits |= 1;
+		}
+
+		_bitmap_mergewords(rel, lovItem, lastBufferP, numWordsP,
+						   currTidNumber);
+	}
+}
+
+/*
+ * _bitmap_create_lovitem() -- create a new LOV item.
+ *
+ * Create a new LOV item and append this item into the last LOV page.
+ * Each LOV item is associated with one distinct value for attributes
+ * to be indexed. This function also inserts this distinct value along
+ * with this new LOV item's block number and offsetnumber into the
+ * auxiliary heap and its b-tree of this bitmap index.
+ *
+ * This function returns the block number and offset number of this
+ * new LOV item.
+ */
+void _bitmap_create_lovitem(Relation rel,
+							Buffer metabuf,
+							uint64 currTidNumber,
+							TupleDesc tupDesc, Datum* attdata, bool* nulls,
+							Relation lovHeap, Relation lovIndex,
+							BlockNumber* lovBlockP, OffsetNumber* lovOffsetP)
+{
+	BMMetaPage		metapage;
+	Buffer			currLovBuffer;
+	Page			currLovPage;
+	Datum*			lovDatum;
+	bool*			lovNulls;
+	OffsetNumber	itemSize;
+	BMLOVItem		lovItem;
+	int				numOfAttrs;
+
+	numOfAttrs = tupDesc->natts;
+
+	/* Get the last LOV page */
+	LockBuffer(metabuf, BM_READ);
+	metapage = (BMMetaPage) BufferGetPage(metabuf);
+	*lovBlockP = metapage->bm_lov_lastpage;
+	LockBuffer(metabuf, BUFFER_LOCK_UNLOCK);
+
+	currLovBuffer = _bitmap_getbuf(rel, *lovBlockP, BM_WRITE);
+	currLovPage = BufferGetPage(currLovBuffer);
+
+	lovItem = _bitmap_formitem(currTidNumber);
+
+	*lovOffsetP = OffsetNumberNext(PageGetMaxOffsetNumber(currLovPage));
+	itemSize = sizeof(BMLOVItemData);
+
+	/*
+	 * If there is no enough space in the last LOV page for
+	 * a new item, create a new LOV page, and update the metapage.
+	 */
+	if (itemSize > PageGetFreeSpace(currLovPage))
+	{
+		Buffer		newLovBuffer;
+
+		/* create a new LOV page. */
+		newLovBuffer = _bitmap_getbuf(rel, P_NEW, BM_WRITE);
+		_bitmap_init_lovpage(rel, newLovBuffer);
+
+		_bitmap_log_newpage(rel, XLOG_BITMAP_INSERT_NEWLOV, 
+							newLovBuffer, NULL);
+	
+		_bitmap_relbuf(currLovBuffer);
+
+		currLovBuffer = newLovBuffer;
+		currLovPage = BufferGetPage (currLovBuffer);
+		*lovOffsetP = OffsetNumberNext(PageGetMaxOffsetNumber(currLovPage));
+		*lovBlockP = BufferGetBlockNumber(currLovBuffer);
+
+		LockBuffer(metabuf, BM_WRITE);
+		metapage->bm_lov_lastpage = 
+			BufferGetBlockNumber(currLovBuffer);
+
+		_bitmap_log_metapage(rel, metapage);
+		_bitmap_wrtnorelbuf(metabuf);
+		LockBuffer(metabuf, BUFFER_LOCK_UNLOCK);
+	}
+
+	lovDatum = palloc0((numOfAttrs+2)*sizeof(Datum));
+	lovNulls = palloc0((numOfAttrs+2)*sizeof(bool));
+	memcpy(lovDatum, attdata, numOfAttrs * sizeof(Datum));
+	memcpy(lovNulls, nulls, numOfAttrs * sizeof(bool));
+	lovDatum[numOfAttrs] = Int32GetDatum(*lovBlockP);
+	lovNulls[numOfAttrs] = false;
+	lovDatum[numOfAttrs+1] = Int16GetDatum(*lovOffsetP);
+	lovNulls[numOfAttrs+1] = false;
+
+	_bitmap_insert_lov(lovHeap, lovIndex, lovDatum, lovNulls);
+
+	if (PageAddItem(currLovPage, (Item)lovItem, itemSize, *lovOffsetP,
+					LP_USED) == InvalidOffsetNumber)
+		ereport(ERROR,
+				(errcode(ERRCODE_INTERNAL_ERROR),
+				errmsg("failed to add LOV item to \"%s\"",
+				RelationGetRelationName(rel))));
+
+
+	_bitmap_log_lovitem(rel, currLovBuffer, true, *lovOffsetP, lovItem);
+
+	_bitmap_wrtbuf(currLovBuffer);
+
+	pfree(lovItem);
+	pfree(lovDatum);
+	pfree(lovNulls);
+}
+
+/*
+ * _bitmap_write_tids() -- write out all tids that are stored
+ *	in a given array.
+ */
+void
+_bitmap_write_tids(Relation rel, Buffer metabuf,
+				   BlockNumber lovBlock, OffsetNumber lovOffset,
+				   uint64* tids, uint32	numTids)
+{
+	Buffer		currLovBuffer;
+	Page		currLovPage;
+	uint32		tidNo;
+	Buffer		lastBuffer;
+	BMLOVItem	lovItem;
+	uint32		numWords;
+	BMMetaPage	metapage;
+	uint32		numNewTids;
+
+	Assert(BlockNumberIsValid(lovBlock) && numTids>=1);
+
+	currLovBuffer = 
+		_bitmap_getbuf(rel, lovBlock, BM_WRITE);
+	currLovPage = BufferGetPage(currLovBuffer);
+
+	lovItem = (BMLOVItem)
+		PageGetItem(currLovPage, PageGetItemId(currLovPage, lovOffset));
+
+	lastBuffer = _bitmap_get_lastbitmappagebuf(rel, lovItem);
+
+	numWords = 0;
+	numNewTids = 0;
+
+	for (tidNo=0; tidNo<numTids; tidNo++)
+	{
+		uint64 currTidNumber = tids[tidNo];
+
+		if (lovItem->bm_last_setbit < currTidNumber)
+			numNewTids ++;
+
+		_bitmap_insertsetbit(rel, lovItem, &lastBuffer, 
+							 &numWords, currTidNumber);
+	}
+
+	/* write lastBuffer to disk */
+	if (BufferIsValid(lastBuffer))
+	{
+		_bitmap_log_bitmappage(rel, lastBuffer, false, numWords);
+		_bitmap_wrtbuf(lastBuffer);
+	}
+
+	_bitmap_log_lovitem(rel, currLovBuffer, false, lovOffset, lovItem);
+	_bitmap_wrtbuf(currLovBuffer);
+	
+	/* update the metapage */
+	LockBuffer(metabuf, BM_WRITE);
+	metapage = (BMMetaPage)BufferGetPage(metabuf);
+	metapage->bm_num_tuples += numNewTids;
+	if (numNewTids < numTids)
+		metapage->bm_need_rebuilt = true;
+	_bitmap_log_metapage(rel, metapage);
+	_bitmap_wrtnorelbuf(metabuf);
+	LockBuffer(metabuf, BUFFER_LOCK_UNLOCK);
+}
+
+/*
+ * _bitmap_write_alltids() -- write all tids in the given buffer into disk.
+ */
+void
+_bitmap_write_alltids(Relation rel, Buffer metabuf, 
+					  BMTidLocsBuffer* tidLocsBuffer,
+					  uint64 tidLocsPerValue,
+					  BlockNumber* lovBlocks)
+{
+	uint32	index;
+	uint64* tidLocs = tidLocsBuffer->bm_tidLocs;
+
+	for (index=0; index<tidLocsBuffer->bm_max_values; index++)
+	{
+		BlockNumber		currLovBlock;
+		OffsetNumber	currLovOffset;
+		uint64* currTidLocs =
+			tidLocs + index*(tidLocsPerValue+1);
+
+		uint64 currNumTids = currTidLocs[0];
+
+		/* convert array index back to currLovBlock and currLovOffset */
+		currLovBlock = lovBlocks[index/BM_MAX_LOVITEMS_PER_PAGE];
+		currLovOffset = index%BM_MAX_LOVITEMS_PER_PAGE + 1;
+
+		if (currNumTids > 0)
+			_bitmap_write_tids(rel, metabuf, currLovBlock, currLovOffset,
+							   currTidLocs+1, currNumTids);
+	}
+}
+
+/*
+ * _bitmap_build_inserttuple() -- insert a new tuple into the bitmap index
+ *	during the bitmap index construction.
+ *
+ * This function is called during the bitmap index construction.
+ *
+ * Each new tuple has an assigned number -- currTidNumber, called a
+ * tid location, which represents the bit location for this tuple in
+ * a bitmap vector. To speed up the construction, this function does not
+ * write this tid location into its bitmap vector immediately. We maintain
+ * a buffer -- BMTidLocsBuffer to keep a fix-sized array of tid locations
+ * for each distinct attribute value.
+ *
+ * If this new tid location causes the corresponding tid array to overflow,
+ * then we write all tid locations stored in this tid array into disk first.
+ * This new tid location will be inserted in the first position of this
+ * tid array.
+ *
+ * If this tuple contains a new value, and the number of distinct values
+ * is beyond a maximum number, stored in the BMTidLocsBuffer (bm_max_values),
+ * then we write out all tid locations in this BMTidLocsBuffer, and
+ * re-allocate this buffer to support more distinct values --
+ * bm_max_values + BM_NUM_DISTINCT_VALUES.
+ */
+void _bitmap_build_inserttuple(Relation rel,
+							   uint64 currTidNumber,
+							   ItemPointerData ht_ctid,
+							   TupleDesc tupDesc, Datum* attdata, bool* nulls,
+							   BMBuildState* state)
+{
+	BlockNumber		lovBlock;
+	OffsetNumber	lovOffset;
+	bool			blockNull, offsetNull;
+	uint32			arrayNo;
+	uint64			*currTidLocs, *tidLocs;
+	uint64			currNumTids;
+	uint64			tidLocsPerValue;
+	BMTidLocsBuffer* tidLocsBuffer;
+	int				attno;
+	bool			allNulls = true;
+
+	tidLocsBuffer = state->bm_tidLocsBuffer;
+	tidLocs = tidLocsBuffer->bm_tidLocs;
+
+	/* Check if all attributes have value of NULL. */
+	for (attno = 0; attno < tupDesc->natts; attno++) {
+		if (!nulls[attno]) {
+			allNulls = false;
+			break;
+		}
+	}
+
+	/* if the inserting tuple has the value of NULL, then
+		the corresponding tid array is the first. */
+	if (allNulls)
+	{
+		lovBlock = BM_LOV_STARTPAGE;
+		lovOffset = 1;
+		arrayNo = 0;
+	}
+
+	/*
+	 * search through the lov heap and index to find the LOV item which
+	 * has the same value as the inserting tuple. If such an item is found,
+	 * we calculate its arrayNo.
+	 */
+	if (_bitmap_findvalue(state->bm_lov_heap, state->bm_lov_index,
+						  attdata, nulls, 
+						  state->bm_lov_scanKeys, state->bm_lov_scanDesc,
+						  &lovBlock, &blockNull, &lovOffset, &offsetNull))
+	{
+		uint16	lovIndex;
+
+		Assert((!blockNull) && (!offsetNull));
+
+		/*
+		 * find the index position for this lovBlock in 
+		 * state->bm_lov_blocks.
+		 */
+		lovIndex = _bitmap_find_lov_index(lovBlock,
+										  state->bm_lov_blocks,
+										  state->bm_num_lov_blocks);
+
+		arrayNo = lovIndex*BM_MAX_LOVITEMS_PER_PAGE + (lovOffset-1);
+	}
+
+	/*
+	 * if the inserting tuple has a new value, then we create a new
+	 * LOV item, and increment tidLocsBuffer->bm_max_values.
+	 */
+	else
+	{
+		_bitmap_create_lovitem(rel, state->bm_metabuf, currTidNumber,
+							   tupDesc, attdata, nulls,
+							   state->bm_lov_heap, state->bm_lov_index,
+							   &lovBlock, &lovOffset);
+
+		/* insert this new lov block number into state->bm_lov_blocks */
+		_bitmap_insert_lov_block_number(lovBlock, 
+										&(state->bm_lov_blocks),
+										&(state->bm_num_lov_blocks),
+										&(state->bm_max_num_lov_blocks));
+
+		arrayNo = (state->bm_num_lov_blocks-1)*
+					BM_MAX_LOVITEMS_PER_PAGE +
+					(lovOffset-1);
+	}
+
+	tidLocsPerValue = BM_MAX_TIDLOCS/tidLocsBuffer->bm_max_values - 1;
+
+	/*
+	 * We want to make sure that tidLocsPerValue is greater than
+	 * or equal to 1.
+	 */
+	if (tidLocsPerValue < 1)
+		tidLocsPerValue = 1;
+
+	/*
+	 * If arrayNo is greater than or equal to 
+	 * tidLocsBuffer->bm_max_values,
+	 * then we write all tid locations into disk, and re-initialize 
+	 * tidLocsBuffer->bm_tidLocsBuffer.
+	 */
+	if (arrayNo >= tidLocsBuffer->bm_max_values)
+	{
+		_bitmap_write_alltids(rel, state->bm_metabuf, tidLocsBuffer, 
+							  tidLocsPerValue,
+							  state->bm_lov_blocks);
+
+		/* re-initialize the buffer */
+		tidLocsBuffer->bm_max_values += BM_NUM_DISTINCT_VALUES;
+		memset(tidLocsBuffer->bm_tidLocs, 0, BM_MAX_TIDLOCS*sizeof(uint64));
+
+		tidLocsPerValue = BM_MAX_TIDLOCS/tidLocsBuffer->bm_max_values - 1;
+		Assert(tidLocsPerValue >= 1);
+	}
+
+	/*
+	 * we try to insert this new tid location into the corresponding array.
+	 * If such an array is full, we will write out all tids stored in this
+	 * array to disk.
+	 */
+	currTidLocs = tidLocs + arrayNo*(tidLocsPerValue+1);
+	currNumTids = currTidLocs[0];
+
+	if (currNumTids >= tidLocsPerValue)
+	{
+		_bitmap_write_tids(rel, state->bm_metabuf, lovBlock, lovOffset,
+						   currTidLocs+1, currNumTids);
+		currTidLocs[0] = 0;
+	}
+
+	/* We simply insert this new tid location into its array. */
+	currTidLocs[0] ++;
+	currTidLocs[currTidLocs[0]] = currTidNumber;
+}
+
+/*
+ * _bitmap_inserttuple() -- insert a new tuple into the bitmap index.
+ *
+ * This function finds the corresponding bitmap vector associated with
+ * the given attribute value, and inserts a set bit into this bitmap
+ * vector. Each distinct attribute value is stored as a LOV item, which
+ * is stored in a list of LOV pages.
+ *
+ * If there is no LOV item associated with the given attribute value,
+ * a new LOV item is created and appended into the last LOV page.
+ *
+ * For support the high-cardinality case for attributes to be indexed,
+ * we also maintain an auxiliary heap and a btree structure for all
+ * the distinct attribute values so that the search for the
+ * corresponding bitmap vector can be done faster. The heap
+ * contains all attributes to be indexed and 2 more attributes --
+ * the block number of the offset number of the block that stores
+ * the corresponding LOV item. The b-tree index is on this new heap
+ * and the key contains all attributes to be indexed.
+ */
+void
+_bitmap_inserttuple(Relation rel, Buffer metabuf,
+					uint64 currTidNumber, ItemPointerData ht_ctid, 
+					TupleDesc tupDesc, Datum* attdata, bool* nulls,
+					Relation lovHeap, Relation lovIndex,
+					ScanKey scanKey, IndexScanDesc scanDesc)
+{
+	BlockNumber		lovBlock;
+	OffsetNumber	lovOffset;
+	bool			blockNull, offsetNull;
+	bool			allNulls = true;
+	int 			attno;
+
+	/* Check if the values of given attributes are all NULL. */
+	for (attno = 0; attno < tupDesc->natts; attno++) {
+		if (!nulls[attno]) {
+			allNulls = false;
+			break;
+		}
+	}
+
+	/*
+	 * if the inserting tuple has the value NULL, then the LOV item is
+	 * the first item in the lovBuffer.
+	 */
+	if (allNulls)
+	{
+		lovBlock = BM_LOV_STARTPAGE;
+		lovOffset = 1;
+	}
+
+	/*
+	 * search through the lov heap and index to find the LOV item which has 
+	 * the same value as the inserting tuple. If such an item is not found, 
+	 * then we create a new LOV item, and insert it into the lov heap and
+	 * index.
+	 */
+	if (!_bitmap_findvalue(lovHeap, lovIndex, attdata, nulls, 
+							scanKey, scanDesc,
+							&lovBlock, &blockNull,
+							&lovOffset, &offsetNull))
+		_bitmap_create_lovitem(rel, metabuf, currTidNumber, tupDesc,
+							   attdata, nulls, lovHeap, lovIndex,
+							   &lovBlock, &lovOffset);
+
+
+	/*
+	 * Here, we have found the block number and offset number of the
+	 * LOV item that points to the bitmap page, to which we will
+	 * append the set bit.
+	 */
+	_bitmap_write_tids(rel, metabuf, lovBlock, lovOffset,
+					   &currTidNumber, 1);
+}
+
+/*
+ * _bitmap_buildinsert() -- insert an index tuple during index creation.
+ */
+void
+_bitmap_buildinsert(Relation rel, ItemPointerData ht_ctid,
+					Datum* attdata, bool* nulls,
+					BMBuildState*	state)
+{
+	TupleDesc	tupDesc;
+	uint64		tidOffset;
+
+	Assert(ItemPointerGetOffsetNumber(&ht_ctid) <= MaxNumHeapTuples);
+
+	tidOffset = 
+		((uint64)ItemPointerGetBlockNumber(&ht_ctid) * 
+		 MaxNumHeapTuples)
+		+ ((uint64)ItemPointerGetOffsetNumber(&ht_ctid));
+
+	tupDesc = RelationGetDescr(rel);
+
+	/* insert a new bit into the corresponding bitmap */
+	_bitmap_build_inserttuple(rel, tidOffset, ht_ctid,
+							  tupDesc, attdata, nulls, state);
+}
+
+/*
+ * _bitmap_doinsert() -- insert an index tuple for a given tuple.
+ */
+void
+_bitmap_doinsert(Relation rel, ItemPointerData ht_ctid,
+				 Datum* attdata, bool* nulls)
+{
+	uint64			tidOffset;
+
+	TupleDesc		tupDesc;
+	Buffer			metabuf;
+	BMMetaPage		metapage;
+	Relation		lovHeap, lovIndex;
+	ScanKey			scanKeys;
+	IndexScanDesc	scanDesc;
+	int				attno;
+
+	tupDesc = RelationGetDescr(rel);
+	if (tupDesc->natts <= 0)
+		return ;
+
+	Assert(ItemPointerGetOffsetNumber(&ht_ctid) <= MaxNumHeapTuples);
+	tidOffset = 
+		((uint64)ItemPointerGetBlockNumber(&ht_ctid) * 
+		 MaxNumHeapTuples)
+		+ ((uint64)ItemPointerGetOffsetNumber(&ht_ctid));
+
+	/* insert a new bit into the corresponding bitmap using the HRL scheme */
+	metabuf = _bitmap_getbuf(rel, BM_METAPAGE, BM_READ);
+	metapage = (BMMetaPage)BufferGetPage(metabuf);
+	_bitmap_open_lov_heapandindex(rel, metapage,
+								  &lovHeap, &lovIndex, RowExclusiveLock);
+	LockBuffer(metabuf, BUFFER_LOCK_UNLOCK);
+
+	scanKeys = (ScanKey)
+		palloc0(tupDesc->natts * sizeof(ScanKeyData));
+
+	for (attno = 0; attno<tupDesc->natts; attno++) {
+		RegProcedure	opfuncid;
+		ScanKey			scanKey;
+
+		opfuncid = equality_oper_funcid(tupDesc->attrs[attno]->atttypid);
+		scanKey = (ScanKey)
+			(((char*)scanKeys) + attno * sizeof(ScanKeyData));
+
+		ScanKeyEntryInitialize
+			(scanKey, SK_ISNULL, attno+1, 
+			BTEqualStrategyNumber, InvalidOid, opfuncid, 0);
+	}
+
+	scanDesc =
+		index_beginscan (lovHeap, lovIndex, true, SnapshotAny,
+						 tupDesc->natts, scanKeys);
+
+	/* insert this new tuple into the bitmap index. */
+	_bitmap_inserttuple
+			(rel, metabuf, tidOffset, ht_ctid,
+			 tupDesc, attdata, nulls, 
+			 lovHeap, lovIndex, scanKeys, scanDesc);
+
+	index_endscan(scanDesc);
+	_bitmap_close_lov_heapandindex(lovHeap, lovIndex, RowExclusiveLock);
+
+	ReleaseBuffer(metabuf);
+	pfree(scanKeys);
+}
